<template>
  <q-form
    ref="form"
    @submit="onOKClick"
  >
    <q-card-section>
      <q-input
        v-model="name"
        filled
        label="Název *"
        lazy-rules
        :rules="[
          val => val && val.length > 0 || 'Prosím zadejte název',
          val => val.length < 255 || 'Název je příliš dlouhý'
        ]"
        :disable="detail"
      />

      <q-checkbox
        v-model="sequence"
        filled
        label="Spouštět za sebou"
        :disable="detail"
      />

      <q-select
        v-model="journey"
        filled
        counter
        multiple
        :option-label="journeyLabel"
        option-value="id"
        label="Jízdy"
        :options="journeyOptions"
        :disable="detail"
        @filter="loadJourneyOptions"
      />

      <draggable
        :list="journey"
        item-key="value"
        class="q-list q-list--bordered q-list--separator q-mt-xl"
        ghost-class="ghost"
        :disabled="detail"
      >
        <template #item="{ element }">
          <q-item
            v-ripple
            clickable
          >
            <q-item-section avatar>
              <q-icon
                v-if="!detail"
                name="drag_indicator"
                color="primary"
              />
            </q-item-section>

            <q-item-section>{{ journeyLabel(element) }}</q-item-section>

            <q-item-section side>
              <q-btn
                v-if="!detail"
                icon="close"
                flat
                round
                @click="() => deleteSelected(element.id)"
              />
            </q-item-section>
          </q-item>
        </template>
      </draggable>
    </q-card-section>

    <q-separator />

    <buttons
      v-if="showBtns"
      :add-label="addLabel"
      @onCancelClick="$emit('onCancelClick')"
    />
  </q-form>
</template>
<script lang="ts">
import { ref } from '@vue/reactivity'
import _ from 'lodash'
import { useQuasar } from 'quasar'
import { defineComponent } from 'vue'
import draggable from 'vuedraggable'
import { JourneyModel } from 'web_trains_types'

import Buttons from '@/components/Timetable/Buttons.vue'
import { journeyService, timetableService } from '@/service'

export default defineComponent({
  name: 'TimetableAdd',
  components: {
    draggable,
    Buttons
  },
  props: {
    id: {
      type: Number,
      required: true
    },
    showBtns: {
      type: Boolean,
      reguired: false,
      default: true
    },
    detail: {
      type: Boolean,
      reguired: false,
      default: false
    }
  },
  emits: [
    'onOKClick',
    'onCancelClick'
  ],
  setup (props, { emit }): any {
    const $q = useQuasar()

    const name = ref('')
    const journey = ref<JourneyModel[]>([])
    const sequence = ref<boolean>(false)

    const journeyOptions = ref<JourneyModel[]>()

    const addLabel = ref('Uložit')
    const form = ref()

    const loadJourneyOptions = (val: string, update: any) => {
      if (journeyOptions.value !== undefined) {
        update()
        return
      }

      journeyService.getAll()
        .then((data) => {
          update(() => {
            journeyOptions.value = data
          })
        })
    }

    const addTimetable = (journeyIds: Array<number>) => {
      return timetableService
        .add({
          name: name.value,
          sequence: sequence.value,
          journey: journeyIds
        })
        .then((data) => {
          $q.notify({
            type: 'positive',
            message: 'Jízdní řád byl přidán'
          })
          emit('onOKClick', data)
        })
    }

    const updateTimetable = (id: number, journeyIds: Array<number>) => {
      return timetableService
        .patch(id, {
          name: name.value,
          sequence: sequence.value,
          journey: journeyIds
        })
        .then(() => {
          $q.notify({
            type: 'positive',
            message: 'Jízdní řád byl upraven'
          })
          emit('onOKClick')
        })
    }

    const onOKClick = () => {
      $q.loading.show()

      const journeyIds = journeyService.modelToIds(journey.value)

      let addUpdatePromise = null

      if (props.id === 0) {
        addUpdatePromise = addTimetable(journeyIds)
      } else {
        addUpdatePromise = updateTimetable(props.id, journeyIds)
      }

      addUpdatePromise
        .finally(() => {
          $q.loading.hide()
        })
    }

    const deleteSelected = (id: number) => {
      if (journey.value === undefined) {
        return
      }

      _.remove(journey.value, (obj) => obj.id === id)
    }

    if (props.id !== 0) {
      $q.loading.show()

      addLabel.value = 'Upravit'

      timetableService.get(props.id)
        .then((timetable) => {
          name.value = timetable.name
          sequence.value = !!timetable.sequence

          if (timetable.journey) {
            journey.value = timetable.journey
          }
        })
        .finally(() => { $q.loading.hide() })
    }

    return {
      onOKClick,
      name,
      sequence,
      loadJourneyOptions,
      journeyOptions,
      journey,
      deleteSelected,
      journeyLabel: journeyService.getLabel,
      addLabel,
      form,
      submit: () => form.value.submit()
    }
  }
})

</script>
